import 'package:flight_script/flight_script.dart';

/// functions have access to the scopes that were available when they were defined
/// This gives them access to variables that may otherwise be inaccessible
/// We can use this to create private variables - accessing n from outside the
/// outer function here would be impossible if we do not call `getter`
/// notice we return the two inner functions and assign them both - multiple returns are allowed
const program = """
  
  {
    0 :n
    {
      n 1 +() ::n
    } 
    {
      n
    }
  }() :getter :inc
  
  inc()
  inc()
  getter()
""";

void main() {
  final interpreter = Interpreter();
  final result = interpreter.eval(program);
  print(result);
}
