import 'package:flight_script/flight_script.dart';

/// as well as using dart to call flight, we can use flight to call dart functions
/// and push dart_values to the vm using `bind`
/// dart functions must use the Dart-API - it's similar to Lua's stack (more example to follow)
const program = """
  hello_text print()
  
  "Hello from flight!" dart_print()  
""";

void main() {
  final interpreter = Interpreter();

  interpreter.bind("hello_text", "Hello from dart!");

  interpreter.bind("dart_print", (VirtualMachine vm) {
    print(vm.popString());
  });

  interpreter.eval(program);
}
