import 'package:flight_script/flight_script.dart';

/// functions allways get their own scope - variable assignments will shadow
/// variables in outer scopes. Variables can be read from outer scopes
/// using the `::` double-assignment operator you can assign variables to the outer scope
/// this program will print 6, as the first function assigns its result to its own `n`
const program = """
  
  5 :n
  
  { 
    1 n +() :n
  } ()
  
  { 
    1 n +() ::n
  } ()
  
  n
  
""";

void main() {
  final interpreter = Interpreter();
  final result = interpreter.eval(program);
  print(result);
}
