import 'interfaces.dart';

class Push extends Command<dynamic> {
  const Push(dynamic data) : super(data);
}

class Pop extends Command<void> {
  const Pop() : super(null);
}

class StoreParameters {
  final bool shadows;
  final FlightValue? key;
  final FlightValue? value;

  const StoreParameters(this.shadows, this.key, this.value);
}

class Store extends Command<StoreParameters> {
  Store({bool shadows = true, FlightValue? key, FlightValue? value})
      : super(StoreParameters(shadows, key, value));
}

class Load extends Command<void> {
  const Load() : super(null);
}

class Execute extends Command<void> {
  const Execute() : super(null);
}
