import 'package:flight_script/vm/interfaces.dart';
import 'package:flight_script/vm/values.dart';
import 'package:test/test.dart';

void main() {
  group(
    'StringValues should be equal if they have the same string in them',
    () {
      test('equality', () {
        final string1 = StringValue("Foo");
        final string2 = StringValue("Foo");
        expect(string1 == string2, isTrue);
      });
      test('hashcode', () {
        final string1 = StringValue("Foo");
        final string2 = StringValue("Foo");
        expect(string1.hashCode == string2.hashCode, isTrue);
      });
      test('as map keys', () {
        final string1 = StringValue("Foo");
        final string2 = StringValue("Foo");
        final map = <FlightValue, FlightValue>{
          string1: NumberValue(5),
        };
        expect(map[string2]!.value, equals(5));
      });
    },
  );
}
